﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using gma.System.Windows;
using System.Net;
using System.Net.Sockets;
using System.IO;


namespace ProjectForm01
{
    public struct MPacket
    {
        public int type;    //0:mouse move 1:mouse click 2:mouse release 3: mouse push
        public int etype;   //             1:left, 2:Right
        public int data1;   // x position
        public int data2;   // y position
    }

    public partial class NewForm : Form
    {
        private int x;
        private int y;
        private int fx;
        private int fy;

        UserActivityHook actHook;
        NetworkStream stream;
        TcpClient client;


        public byte[] GetBytes_MPacket(MPacket packet)
        {
            byte[] btBuffer = new byte[16];

            MemoryStream ms = new MemoryStream(btBuffer, true);
            BinaryWriter bw = new BinaryWriter(ms);

            bw.Write(packet.type);
            bw.Write(packet.etype);
            bw.Write(packet.data1);
            bw.Write(packet.data2);

            bw.Close();
            ms.Close();

            return btBuffer;
        }
        /*
        public byte[] GetBytes_KPacket(KPacket packet)
        {
            byte[] btBuffer = new byte[26];

            MemoryStream ms = new MemoryStream(btBuffer, true);
            BinaryWriter bw = new BinaryWriter(ms);

            bw.Write(packet.type);
            bw.Write(packet.etype);
            bw.Write(packet.keychar);
            bw.Write(packet.data1);
            bw.Write(packet.data2);
            bw.Write(packet.data3);
            bw.Write(packet.data4);

            bw.Close();
            ms.Close();

            return btBuffer;
        }
        */
        public void Mouse_Send(int type, int etype, int data1, int data2)
        {
            MPacket packet = new MPacket();
            packet.type = type;
            packet.etype = etype;
            packet.data1 = data1;
            packet.data2 = data2;

            byte[] buffer = GetBytes_MPacket(packet);
            stream.Write(buffer, 0, 16);
        }

        public NewForm()
        {
            InitializeComponent();
        }

        private void NewForm_MouseLeave(object sender, EventArgs e)
        {
            if (fx != 0)
                Cursor.Position = new Point(x, y);
            else
            {              
                Cursor.Show();
                Cursor.Position = new Point(1278, y);
                this.WindowState = FormWindowState.Minimized;             
            }
        }

        private void NewForm_MouseMove(object sender, MouseEventArgs e)
        {
            x = Cursor.Position.X;
            y = Cursor.Position.Y;
            fx = e.X;
            fy = e.Y;
            
           if(e.X<=800 && e.Y <= 600) 
                Mouse_Send(0, 0, e.X, e.Y);          
        }

        private void NewForm_Load(object sender, EventArgs e)
        {       
            client = new TcpClient();
            string DestIP = "192.168.21.129";
            client.Connect(DestIP, 5425);
            stream = client.GetStream();            
        }

        private void NewForm_MouseClick(object sender, MouseEventArgs e)
        {   //Left 1, Right 2    doubleClick 1
            
            if(e.Button ==MouseButtons.Left)            
                Mouse_Send(1, 1, e.X, e.Y);
            else
                Mouse_Send(1, 3, e.X, e.Y);
            
        }

        private void NewForm_MouseDoubleClick(object sender, MouseEventArgs e)
        {   //Left 1, Right 2,   doubleClick 2
            Mouse_Send(1, 4, e.X, e.Y);
        }

        private void NewForm_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
                Mouse_Send(2, 1, e.X, e.Y);
            else
                Mouse_Send(2, 3, e.X, e.Y);
        }

        private void NewForm_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
                Mouse_Send(3, 1, e.X, e.Y);
            else
                Mouse_Send(3, 3, e.X, e.Y);
        }
    }
}